HDU 1466 計算直線的交點數(簡單dp)

畫船聽雨發表於2014-03-08

解體思路:設a1+a2+......+an = n;代表每組平行的直線有ai個。所以一共有交點

s=(a1*(n-a1)+a2*(n-a2)+....+an*(n-an))/2。化簡的到2*s = (a1n+..+an*n)-(a1^2+a2^2+...an^2) = (n*n)-(a1^2+a2^2+...an^2)。所以列舉第i條直線中有多少個ai的和。if(dp[i-k][j-k*k] == 1) dp[i][j]就可達。

計算直線的交點數

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 7619    Accepted Submission(s): 3402


Problem Description
平面上有n條直線,且無三線共點,問這些直線能有多少種不同交點數。
比如,如果n=2,則可能的交點數量為0(平行)或者1(不平行)。
 

Input
輸入資料包含多個測試例項,每個測試例項佔一行,每行包含一個正整數n(n<=20),n表示直線的數量.
 

Output
每個測試例項對應一行輸出,從小到大列出所有相交方案,其中每個數為可能的交點數,每行的整數之間用一個空格隔開。
 

Sample Input
2 3
 

Sample Output
0 1 0 2 3
 

#include <algorithm>
#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <iomanip>
#include <stdio.h>
#include <string>
#include <queue>
#include <cmath>
#include <stack>
#include <map>
#include <set>
#define eps 1e-7
#define M 1000100
#define LL __int64
#define INF 0x3f3f3f3f
#define PI 3.1415926535898

const int maxn = 510;
using namespace std;

int dp[maxn][maxn];
int num[maxn];

/*
一共用了i條直線,這些直線隨意分組,每組的平方的和為j,
如果dp[i][j]為1,代表存在這種情況
*/
int main()
{
    int n;
    while(cin >>n)
    {
        memset(dp, 0 , sizeof(dp));
        dp[0][0] = 1;
        for(int i = 0; i <= n; i++)
            for(int j = 0; j <= i*i; j++)
                for(int k = 0; k <= i && k*k <= j; k++)
                    if(dp[i-k][j-k*k])
                        dp[i][j] = 1;
        int t = 0;
        for(int i = 0; i <= n*n; i++)
            if(dp[n][i])
                num[t++] = i;
        int cnt[maxn];
        for(int i = 0; i < t; i++)
            cnt[i] = n*n-num[i];
        sort(cnt, cnt+t);
        for(int i = 0; i < t-1; i++)
            cout<<(cnt[i]/2)<<" ";
        cout<<(cnt[t-1]/2)<<endl;
    }
    return 0;
}


相關文章